/********************************************************************************
 *                                                                              *
 *                            Styles for SiteJS.org                             *
 *                                                                              *
 *                     Copyright ⓒ 2019-2020 Aral Balkan.                      *
 *                  License: Released under AGPLv3 or later.                    *
 *                                                                              *
 ********************************************************************************/

 #deprecation-notice {
  border: 1em solid mediumvioletred;
  padding: 1em;
  margin-top: -3em;
  margin-bottom: 1em;
  text-align: center;
}

/********************************************************************************
 *                                                                              *
 *                             Cross-platform emoji                             *
 *                                                                              *
 * Emoji graphics copyright ⓒ Twitter, Inc and other contributors. Licensed    *
 * under CC-BY 4.0: https://creativecommons.org/licenses/by/4.0/. With thanks   *
 * to https://github.com/ellekasai/twemoji-awesome for the emoji mappings.      *
 * (We are using the strict subset necessary for the terminal presentation.     *
 *                                                                              *
 ********************************************************************************/

/********************************************************************************
 *                                                                              *
 *                                Global variables                              *
 *                                                                              *
 ********************************************************************************/

:root {
  --alert-height: 2.75rem;
}


/********************************************************************************
 *                                                                              *
 *                               Minimal CSS reset                              *
 *                (https://alligator.io/css/minimal-css-reset/)                 *
 *                                                                              *
 ********************************************************************************/

html { box-sizing: border-box; }
*, *:before, *:after { box-sizing: inherit; }
body, h1, h2, h3, h4, h5, h6, p, ol, ul { margin: 0; padding: 0; font-weight: normal; }
ol, ul { list-style: none; }
img { max-width: 100%; height: auto; }


/********************************************************************************
 *                                                                              *
 *                        General layout and typography                         *
 *                                                                              *
 ********************************************************************************/

html {
  /* Responsiveness is mainly defined by altering the root foot size (root em). */
  font-size: clamp(100%, 2vw, 125%);

  /* Use system fonts. */
  font-family:
    -apple-system,
    BlinkMacSystemFont,
    "Segoe UI",
    Cantarell,
    Ubuntu,
    Helvetica,
    Arial,
    sans-serif;

  margin: 0;
  padding: 0;
  background-color: whitesmoke;
}

body {
  max-width: 960px;
  color: #304349;

  /* Horizontally centre the body. */
  margin-left: auto;
  margin-right: auto;
}

aside, p {
  margin-bottom: 1em;
}

aside, aside p {
  font-style: italic;
  font-size: 1rem;
}

h1 {
  font-size: 5rem;
  text-align: center;
  font-weight: 200;
  padding-top: 0.25em;
  margin-bottom: 0.25em;
}

h1 > strong {
  font-weight: 400;
}

h2 {
  font-size: 2.5rem;
  margin-top: 0.75em;
  margin-bottom: 0.25em;
  font-weight: 300;
}

h2 + h3 {
  margin-top:0;
}

h3 {
  font-size: 1.5rem;
  margin-bottom: 1rem;
}

ol li::marker {
  font-size: 1.5rem;
  font-weight: 500;
  line-height: 1.5;
  margin-bottom: 0.5em;
}

h4 {
  font-size: 1rem;
  font-weight: 500;
  line-height: 1.5;
  margin-top: 1em;
  margin-bottom: 0.5em;
}

strong {
  font-weight: 600;
}

a {
  color: #334b4c;
  text-decoration: underline;
  text-decoration-color: #CCD6CE;

  /* Make the links thicker and offset them further away. */
  text-decoration-thickness: 0.2em;
  text-underline-offset: 0.25em;
}

a:hover {
  color: #466B6A;
}

ol {
  list-style-type: decimal;
}

main ol li {
  margin-bottom: 1.5em;
}

ol ol, aside > ol {
  list-style-type: lower-roman;
}

ol ol li::marker, aside > ol li::marker {
  font-size: 1em;
  font-weight: normal;
}

pre, code, code span {
  font-family: "SFMono-Regular",
  Consolas,
  "Fira Code",
  "Liberation Mono",
  Menlo,
  Courier,
  monospace !important;
  /* font-weight: 100 !important; */
  background-color: #eaeaea !important;
}

pre {
  line-height: 1.5;
  margin-left: -1em;
  margin-right: -1em;
  padding-left: 1em;
  padding-right: 0.5em;
  padding-top: 0.5em;
  padding-bottom: 0.5em;
  border-radius: 0.5em;
}

aside pre {
  border-radius: 0;
  padding-left: 2.5em;
}

/* Make sure all code wraps so we don’t overflow the page width. */
/* Courtesy: https://gist.github.com/tcr/1321968                 */

pre, code[class*="language-"], pre[class*="language-"], pre code span {
  /* Make sure preformatted text wraps. */
  white-space: pre-wrap;       /* css-3 */
  white-space: -moz-pre-wrap;  /* Mozilla, since 1999 */
  white-space: -pre-wrap;      /* Opera 4-6 */
  white-space: -o-pre-wrap;    /* Opera 7 */
  word-wrap: break-word;       /* Internet Explorer 5.5+ */
}

.preserve-whitespace {
  white-space: pre;
}

.hidden {
  display: none;
}


/********************************************************************************
 *                                                                              *
 *                                     Tabs                                     *
 *                                                                              *
 ********************************************************************************/

#platform-tabs {
  text-align: center;
  border-bottom: 0.25em solid lightblue;
  margin-bottom: 2em;
}

#platform-tabs li {
  display: inline-block;
  margin-left: 0.25em;
}

#platform-tabs li:first-of-type {
  margin-left: 0;
}

#platform-tabs li button.active {
  background-color: lightblue;
}

#platform-tabs li button {
  font-family: inherit;
  font-size: 1.5em;
  border: none;
  background-color: transparent;
  padding-left: 2rem;
  padding-right: 2rem;
  padding-top: 0.75rem;
  padding-bottom: 0.75rem;
  margin: 0;
  color: #304349;
}


/********************************************************************************
 *                                                                              *
 *                            Syntax highlighting                               *
 *                                                                              *
 ********************************************************************************/

 .hljs-attribute, .hljs-name, .hljs-tag{
  font-weight: inherit;
}

.hljs-meta {
  font-weight: inherit;
}

/********************************************************************************
 *                                                                              *
 *                                     Header                                   *
 *                                                                              *
 ********************************************************************************/

header h2, #small-web-details h3 {
  font-size: 2em;
  font-weight: 300;
  text-align: center;
  margin-top: -0.5em;
  margin-bottom: 2.25em;
}

header h2 {
  padding-left: 1em;
  padding-right: 1em;
}

#header-image {
  margin-top: -2em;
}


/********************************************************************************
 *                                                                              *
 *                                  Navigation                                  *
 *                                                                              *
 ********************************************************************************/

nav {
  font-size: 1.25em;
  text-align: center;
  margin-top: -4%;
  background-color: rgb(230,230,230);
  padding-top: 1.75em;
  padding-bottom: 0.5em;
}

nav > ul {
  list-style: none;
  padding-left: 0.25em;
  padding-right: 0.25em;
}

nav li, nav a {
  color: #4D7072;
}

nav a:hover {
  color:#334b4c;
  border-bottom: 2px solid #334b4c;
}

nav li {
  display: inline;
  padding-right: 1em;
  line-height: 1.5;
}

nav a {
  text-decoration: none;
}

nav li:last-of-type {
  padding-right: 0;
}

nav li.selected {
  color: #151D1F;
}

/********************************************************************************
 *                                                                              *
 *                                     Tips                                     *
 *                                                                              *
 ********************************************************************************/

aside, #small-web-details li {
  border: 0.25em solid lightgrey;
  background-color: #ffffff;
  border-radius: 1em;
  padding: 1em;
}

aside {
  margin-left: -1.5em;
  margin-right: -1.5em;
  margin-top: 2em;
  margin-bottom: 2em;
  padding-bottom: 0;
}

aside::before {
  background-image: url(../images/emoji/site.js-logo.svg);
  background-color: gainsboro;
  background-repeat: no-repeat;
  border-radius: 1.5em;
  padding: 1.5em;
  background-position: 50% 50%;
  background-size: 2em 2em;
  float: left;
  margin-right: 1em;
  margin-bottom:0.5em;
  vertical-align: middle;
  width: 2em;
  height: 2em;
  content: '';
}


/********************************************************************************
 *                                                                              *
 *                              Small Web section                               *
 *                                                                              *
 ********************************************************************************/

#small-web h2, .highlights h2, main h2 {
  text-align: center;
  margin-top: 4rem;
  margin-bottom: 4rem;

  border-top: 1px solid gray;
  border-bottom: 1px solid gray;

  padding-top: 1em;
  padding-bottom: 1em;

  width: 75%;
  margin-left: auto;
  margin-right: auto;
}

#small-web-details {
  display: flex;
  justify-content: space-between;
}

#small-web-details li {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  flex-basis: 32%;
}

#small-web-details li h3 {
  margin-bottom: 1em;
}

#small-web-details li p {
  margin-top: 1em;
  text-align: center;
}

/* Also see header section for additional styles. */
#small-web-details h3 {
  margin: 0;
  padding: 0;
}

#small-web-details li img {
  max-width: 100%;
}

/********************************************************************************
 *                                                                              *
 *                                      News                                    *
 *                                                                              *
 ********************************************************************************/

#news {
  margin-top: 3em;
}

#news p {
  margin-left: 1.5rem;
margin-right: 0.5rem;
}

/********************************************************************************
 *                                                                              *
 *                                   Highlights                                 *
 *                                                                              *
 ********************************************************************************/

.highlights ul {
  display: grid;
  grid-template-columns: 47.5% 47.5%;
  grid-column-gap: 5%;
  margin-left: auto;
  margin-right: auto;
}

.highlights li {
  font-size: 1.5em;
  list-style-type: none;
  margin-bottom: 0.5em;
}

/* Remove all margins from elements in the last row of highlights */
.highlights li:nth-last-of-type(2),
.highlights li:last-of-type,
.highlights li:nth-last-of-type(2) p,
.highlights li:last-of-type p {
  margin-bottom: 0;
}

.highlights li p {
  margin-left: 2.3em;
}

.highlights h3 {
  margin-bottom: 0.15rem;
}

.highlights h3::before {
  content: '';
  display: inline-block;
  background-repeat: no-repeat;
  height: 1.5rem;
  width: 1.5rem;
  margin-right: 0.75rem;
  vertical-align: -0.2rem;
}

#features h3::before {
  background-image: url('../images/emoji/2705.svg'); /* Check mark. */
}

#further-reading h3::before {
  background-image: url('../images/emoji/1f4d6.svg'); /* Open book. */
}


/********************************************************************************
 *                                                                              *
 *                                 Main content                                 *
 *                                                                              *
 ********************************************************************************/

main, footer {
  padding-left: 3rem;
  padding-right: 3rem;
}

main p, main li, footer p {
  font-size: 1rem;
  line-height: 1.5;
  margin-bottom: 1em;
}

main li {
  margin-bottom: 0;
}


/********************************************************************************
 *                                                                              *
 *                                 Introductions                                *
 *                                                                              *
 ********************************************************************************/

.introduction {
  margin-bottom: 3rem;
}

.introduction p {
  font-size: 1.25em;
  font-weight: 300;
}


/********************************************************************************
 *                                                                              *
 *                                    Copy Alert                                *
 *                                                                              *
 ********************************************************************************/

#copy-alert {
  display: block;
  background-color: gray;
  color: whitesmoke;
  height: var(--alert-height);
  position: fixed;
  text-align: center;
  top: calc(var(--alert-height) * -1);
  left: 0;
  width: 100%;
  padding:0;
  margin: 0;
}

#copy-alert p {
  /* Vertically centre the paragraph in the alert. */
  margin-top: .75rem;
  font-size: 1.25rem;
  line-height: 1;
}

.show-copy-alert {
  animation: show-copy-alert 0.3s ease forwards;
}

.hide-copy-alert {
  animation: hide-copy-alert 0.3s ease forwards;
}

@keyframes show-copy-alert {
  0% { opacity: 0; }
  50% { opacity: 1; }
  100% { top: 0; }
}

@keyframes hide-copy-alert {
  0% { opacity: 1; top: 0;}
  50% { top: calc(var(--alert-height) * -1); }
  100% { opacity: 0; }
}


/********************************************************************************
 *                                                                              *
 *                                      About                                   *
 *                                                                              *
 ********************************************************************************/

#about {
  margin-bottom: 3rem;
}


/********************************************************************************
 *                                                                              *
 *                                     Footer                                   *
 *                                                                              *
 ********************************************************************************/

footer {
  margin-bottom: 2rem;
}

#copyright {
  margin-top: 1em;
  text-align: center;
}

#logo {
  display: block;
  width: 10%;
  margin-left: auto;
  margin-right: auto;
}

/********************************************************************************
 *                                                                              *
 *                                Feature-specific                              *
 *                                                                              *
 ********************************************************************************/

/* If they can hover, they can click. */
@media (hover: hover) {
  .just-tap      { display: none; }
  .click-and-tap { display: none; }
}

/* If they can’t hover, they can tap. */
@media (hover: none) {
  .just-click    { display: none; }
  .click-and-tap { display: none; }
}


/********************************************************************************
 *                                                                              *
 *                                 Break points                                 *
 *                                                                              *
 ********************************************************************************/

/* Main content padding becomes too large. */
@media(max-width: 768px) {
  main, footer {
    padding-left: 1rem;
    padding-right: 1rem;
  }

  aside {
    margin-left: 0;
    margin-right: 0;
  }

  /* Move the indentation inline. This basically recreates what list-style-position  */
  /* does but list-style-position is buggy on Firefox when the list item contains a  */
  /* block level element like a header. By the way, this is a 20-year-old bug at the */
  /* time of this writing:                                                           */
  /* https://bugzilla.mozilla.org/show_bug.cgi?id=36854                              */

  ol {
    counter-reset: index;
  }

  ol li {
    counter-increment: index;
    list-style-type: none;
  }

  ol li p {
    margin-left: 1.5rem;
    margin-right: 0.5rem;
  }

  aside {
    padding-left: 0;
  }

  aside::before {
    margin-left: 1.5rem;
  }

  aside pre {
    /* padding-left: 1rem; */
    margin-left: 0;
    padding-left: 1.5rem;
  }

  pre {
    margin-left: -1rem;
    margin-right: -1rem;
    padding-left: 2.5rem;
    padding-right: 2.5rem;
    border-radius: 0;
  }

  ol li > h3:first-of-type::before {
    content: counter(index) '. ';
  }

  ol ol li p:first-of-type::before  {
    content: counter(index, lower-roman) '. ';
  }
}

/* The title in the first card wraps to two lines. */
@media(max-width: 615px) {
  #small-web-details {
    flex-wrap: wrap;
  }

  /* Tighten up the spacing and font sizes in the header and navigation. */

  h1 {
    font-size: 4rem;
  }

  header h2 {
    font-size: 1.6em;
  }

  nav li {
    padding-right: 0.5em;
  }

  #small-web h2, .highlights h2, main h2 {
    width: 90%
  }

  /* Make each card fill up the full width of the display so we get a */
  /* single column on narrower viewports.                             */
  #small-web-details li {
    flex-basis: 100%;
    margin-bottom:2em;
  }

  #small-web-details li:last-of-type {
    margin-bottom: 0;
  }

  #small-web-details li h3 {
    font-size: 3rem;
  }

  #small-web-details li p {
    font-size: 1.5rem;
    margin-top: 1.5em;
    text-align: center;
  }

  /* Make the highlights grid a single column as titles wrap into two lines otherwise. */
  .highlights ul {
    grid-template-columns: 100%;
  }

  /* Restore the bottom margins on the next-to-last highlight. */
  .highlights li:nth-last-of-type(2) {
    margin-bottom: 0.5em;
  }

  .highlights li:nth-last-of-type(2) p {
    margin-bottom: 1em;
  }
}

/* The tab bar splits into two lines */
@media(max-width: 472px) {
  #platform-tabs li button {
    font-size: 1.25em;
    padding-left: 1rem;
    padding-right: 1rem;
  }
}

/* The second-level heading in the title wraps to two lines. */
@media(max-width: 367px) {
  header h2 {
    font-size: 1.4em;
  }
}

/* The navigation splits into two lines again. */
@media(max-width: 361px) {
  nav, nav li, nav a {
    font-size: 1em;
    font-weight: 500;
  }
}

/* The tab bar split into two lines again. */
@media(max-width: 337px) {
  #platform-tabs li button {
    font-size: 1em;
    font-weight: 500;
  }
}
